; -----------------------------------------------
; COUNT THE NUMBER OF BYTE DIFFERENT BETWEEN TWO
;            STRINGS OF SAME SIZE
; NASM Assembler
; By Jacques Philippe         February 14th, 2005
; -----------------------------------------------
; PROC NAME : COUNTDIFFBYTES
;   - first argument is a pointer to the first string
;   - second argument is a pointer to the second string 
;   - if string size are different it returns &HFFFFFFFF
;     (= -1  for Signed Long)
;   - if strings are of same size, it returns the number of
;     different chars as same position in string.
; -----------------------------------------------
; Header
    bits 32
; ---- Macros -----------------------------------
    %define Data_0 [ebp+8]
    %define Data_1 [ebp+12]
; ---- End Macros -------------------------------
  segment .text
    start:
    push ebp                            ; enter 0, 0
    mov ebp, esp
; End of Header
; ==== Function =================================
         STRING_SIZES_ARE_DIFFERENT      EQU      0xFFFFFFFF     ; = -1 in RQ
; Check if string have the same size
         mov       esi,      Data_0
         mov       ecx,      [esi-4]             ; ecx is Len(Data_0)
         mov       edi,      Data_1
         mov       edx,      [edi-4]             ; edx is Len(Data_1)
         cmp       ecx,      edx
         jz        .OK_SameSize
         mov       eax,      STRING_SIZES_ARE_DIFFERENT
         jmp       .Finished
.OK_SameSize:
         xor       eax,      eax                 ; eax = 0 = counter diff chars
         cld
.CheckNextByte:
         cmpsb                                   ; compare byte[esi] % byte[edi]  inc esi, inc edi
         jz        .Same_Byte
         inc eax                                 ; inc counter if different
.Same_Byte:
         dec ecx                                 ; until last char is found : ecx = 0
         jnz .CheckNextByte
.Finished:
; ==== End of Function =========================
; Footer
    mov esp, ebp                        ; equiv to Leave
    pop ebp
    ret 16                              ; always 4 arguments with API CallWindowProcA + MeCodePtr
; End of Footer
; *** End of NASM Code
